Many modern software systems continuously reconfigure themselves to (self-)adapt to ever-changing environmental contexts.
Selecting presumably best-fitting next configurations is, however, very challenging, depending on functional and non-functional criteria like real-time constraints as well as inherently uncertain future contexts which makes
greedy one-step decision heuristics ineffective.
In our MODELS paper, we propose a game-theoretic setting for precomputing reconfiguration decisions under partially uncertain real-time behavior.
We employ stochastic timed game automata as reconfiguration model to derive winning strategies which enable the first player (the system) to make fast look-ups for presumably best-fitting reconfiguration decisions satisfying the second player (the context).
The corresponding artifact facilitates to derive strategies for a given system specification and to analyze the resulting strategies based on the model checker Uppaal Stratego. In our approach, a specification consists of a *context feature model* in the file format of FeatureIDE (XML) and a set of real-time constraints (RRCL) modeling a self-adaptive system with additional real-time constraints. 
Based on such a specification our tool constructs a corresponding timed game automaton. Afterwards, the timed game automaton can be analyzed by means of the model checker Uppaal Stratego. This comprises both synthesizing and model checking reconfiguration strategies.





